<?php
/**
* @author Michael Flenniken, Jr drakkim@conclavewiz.com
*
* @package phpBB
* @version SVN: $Id: functions_account_link.php 37 2009-02-17 17:01:32Z drakkim $
* @copyright (c) 2008 Michael Flenniken, Jr
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
defined( 'IN_PHPBB' ) or die('Hacking Attempt!');

/**
* Initialize the Linked Account drop down box
* Sets up template variables for linked_acct.html template
* It is recommended to run this function in common.php (after this file is included and $template is initialized)
*/
function account_link_form ()
{
//	global $user;
	global $user, $phpbb_root_path, $phpEx, $template;
	
	$redirect = request_var('reditect',$phpbb_root_path);
	$send_to = $phpbb_root_path ."ucp.$phpEx?i=account_link";
	
	// Make sure user->setup() has been called
	if (empty($user->lang))
	{
		$user->setup();
	}
	$user->add_lang('mods/account_link');

	$s_account_link_options ='';

	if ($user->data['user_id'] != 1 )
	{
		$linked_accts = get_linked_accounts();
		if (count($linked_accts) > 0) {
			foreach($linked_accts as $key => $value)
			{
				if ($key != $user->data['user_id'])
				{
					$s_account_link_options .= '<option value="' . $key . '">' . $value . '</option>';
				}
			}
		}
	}
	
	$template->assign_vars(array(
		'U_ACCOUNT_LINK_SEND_TO'	=> $send_to,
		'S_ACCOUNT_LINK_OPTIONS'	=> $s_account_link_options,
		'U_THIS_URL'				=> $_SERVER['REQUEST_URI'],
	) );
}

/**
* Retrieve linked accounts for $user_id
*/
function get_linked_accounts ($user_id = 0)
{
	global $db, $user, $auth;
	
	// Declare variables to prevent injection
	$master_id=0;
	$sql_where='';

	if ($user_id==0)
	{
		if ($user->data['user_id'] == 1)
		{
			return false;
		}
		$user_id = $user->data['user_id'];
		$master_id = $user->data['master_id'];
	} else {
		// Look up master_id from USER_TABLE
//		$master_id=0;
	}

	// Look up all users with user_id or master_id matching $user_id or $master_id
	if ($master_id != 0)
	{
		$sql_where = 'OR (user_id = '. $master_id .')
					 OR (master_id = '. $master_id .')';
	}

	$sql = 'SELECT user_id, master_id, username
		FROM ' . USERS_TABLE . '
		WHERE (user_id = '. $user_id .')
		OR (master_id = '. $user_id .')
		' . $sql_where;
	
	$result = $db->sql_query($sql);

	$linked_accounts = array();
	while( ($row = $db->sql_fetchrow($result)) )
	{
		$linked_accounts[$row['user_id'] ] = $row['username'];
	}
	return $linked_accounts;
}

/**
* Start a new session by user_id
* Returns false if the requested id is not linked to the current account
* Based heavily on CB Connector by geeffland (http://cbconnector.com)
*/
function start_session_by_id ($forumid, $persist_login) {
//	global $phpEx, $SID, $_SID, $db, $cache, $config, $phpbb_root_path;
	global $_SID;
	global $user, $auth;
	
	$user->session_begin();
	$auth->acl($user->data);
	$user->setup();	//'ucp'
	$old_session_id = $user->session_id;
	$admin = false;
	$viewonline = true;
	$user->cookie_data['k'] = '';
	$result = $user->session_create($forumid, $admin, $persist_login, $viewonline);
	//$phppBBsessionID = $_SID;
	//return $phppBBsessionID;
	return $result;
	//return $_SID;
}
	
/**
* Switch Users
*
* @todo Kill the old session
*/
function switch_user($forumid)
{
//	global $SID, $_SID, $db, $config;
	global $_SID, $phpbb_root_path, $phpEx;
	global $user, $auth;
	
	$persist_login = false;
	if ($user->cookie_data['k'] != '')
	{
		$persist_login = true;
	}
	
	// Check that this user is linked to the requested user.
	$linked_accounts = get_linked_accounts();
	if (!isset($linked_accounts[$forumid]) )
	{
	// No? Then throw an error and quit now.
//		echo "Bad account";
		$message = sprintf($user->lang['ACCOUNT_NOT_LINKED'], $user->data['username'], get_username_string('username', $forumid, null));
		trigger_error($message);
		return false;
	}
	
//	$user->session_kill();
	$result = start_session_by_id($forumid, $persist_login);
	
	////
	// This code was modified from ucp.php
	////
	
	if ($result === true)
	{
		$redirect = request_var('redirect', "{$phpbb_root_path}index.$phpEx");
		$message = sprintf($user->lang['ACCOUNT_SWITCH_REDIRECT'], $user->data['username']);
		
		$l_redirect = ($redirect === ("{$phpbb_root_path}index.$phpEx" || $redirect === "index.$phpEx")) ? $user->lang['RETURN_INDEX'] : $user->lang['RETURN_PAGE'];	
		
		// append/replace SID (may change during the session for AOL users)
		$redirect = reapply_sid($redirect);

		meta_refresh(3, $redirect);
		trigger_error($message . '<br /><br />' . sprintf($l_redirect, '<a href="' . $redirect . '">', '</a>'));
	}
	else
	{
		trigger_error('ACCT_SWITCH_ERROR');
	}
}

/**
* Check the usernames and passwords for both the master account and the one we're linking to then links the accounts
* *Validates $master_pass, $linked_username, and $linked_pass
*/
function link_account_validate ($master_username, $master_pass, $linked_username, $linked_pass)
{
	global $db, $user;
	
	// Clean usernames
	$linked_username = utf8_clean_string($linked_username);
	$master_username = utf8_clean_string($master_username);
	
	$error = array();
	
	// Retrieve both users
	$sql = 'SELECT user_id, user_password, username_clean'.
		' FROM ' . USERS_TABLE .
		' WHERE (username_clean = "'. $master_username .'")';
	$result = $db->sql_query($sql);
	$master_user = $db->sql_fetchrow($result);
	
	$sql = 'SELECT user_id, user_password, username_clean'.
		' FROM ' . USERS_TABLE .
		' WHERE (username_clean = "'. $linked_username .'")';
	$result = $db->sql_query($sql);
	$linked_user = $db->sql_fetchrow($result);
	
	// Validate users... assume the worst.
	$master_pass_valid = $linked_pass_valid = $linked_username_valid = false;

	// Does $linked_user exist?
	if ($linked_user['username_clean'] == $linked_username)
	{
		$linked_username_valid = true;
	} else {
		$error[] = $user->lang['BAD_LINKED_USERNAME'] . $linked_username;
	}
	
	// Check Master's password
	if (phpbb_check_hash($master_pass, $master_user['user_password']))
	{
		$master_pass_valid=true;
	} else {
		$error[] = $user->lang['BAD_MASTER_PASSWORD'];
	}
	
	// Check Linked's password
	if (phpbb_check_hash($linked_pass, $linked_user['user_password']))
	{
		$linked_pass_valid=true;
	} else {
		$error[] = $user->lang['BAD_LINKED_PASSWORD'];
	}
	
	// Destroy plaintext passwords... just in case.
	unset($master_pass, $linked_pass);
	
	if ($master_pass_valid && $linked_pass_valid)
	{
		return link_accounts($master_user['user_id'], $linked_user['user_id']);
	} else {
		return implode('<br>', $error);
	}
}

/**
* Links accounts by username without validation
* Actually wraps link_accounts()
* *No Validation
*/
/* Breaking code without being used...??
Error on log in / log out: Only variables can be passed by reference
function link_accounts_by_name ($master_username, $linked_username)
{
	$user_id_ary=0;
	 (&$user_id_ary, array ($master_username, $linked_username));
	$master_id = $user_id_ary[0];
	$linked_id = $user_id_ary[1];

	return link_accounts($master_id, $linked_id);
} */

/**
* links the accounts together without validation
* (Sets 'master_id' for user with 'user_id' = $linked_id)
* *No Validation
* @todo: check for errors
*/
function link_accounts($master_id, $linked_id)
{
	global $db;

	$sql = 'UPDATE '. USERS_TABLE 
			.' SET master_id = '. $master_id 
			.' WHERE user_id = '. $linked_id;
			
	// Need to check for errors....
	$result = $db->sql_query($sql);
	return true;
}

/**
* Break the Account Links
* *No Validation
* (Sets 'master_id' to 0)
*/
function unlink_accounts ($user_id)
{
	global $db;

	$sql = 'UPDATE '. USERS_TABLE .'
			SET master_id = 0
			WHERE user_id = '. $user_id;
			
//	echo "un-Linking accounts!!";
	$result = $db->sql_query($sql);
	return true;
}
?>
