<?php
/**
*
* @author Michael Flenniken, Jr drakkim@conclavewiz.com
*
* @package mcp
* @version SVN: $Id: mcp_account_link.php 31 2009-01-26 22:50:38Z drakkim $
* @copyright (c) 2008 Michael Flenniken, Jr
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
defined( 'IN_PHPBB' ) or die('Hacking Attempt!');

/**
*/
require_once($phpbb_root_path . 'includes/functions_account_link.' . $phpEx);

/**
* @package mcp
*/
class mcp_account_link
{
	var $u_action;

	function main($id, $mode)
	{
		global $user, $template, $phpbb_root_path, $phpEx, $db;
		$user->add_lang('mods/account_link');
		$submit = request_var('submit','', true);
		
		$s_hidden_fields = '';
		$error='';
//		$error = request_var('error','');
		switch ($mode)
		{
			case 'manage':
				$this->page_title = 'Manage Linked Accounts';
				$this->tpl_name = 'mcp_account_link_manage';
				if ($user->data['master_id'] != 0)
				{
					$is_master=false;
					
					$sql = 'SELECT username
					FROM ' . USERS_TABLE . '
						WHERE user_id = '. $user->data['master_id'];
					
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
					
					$master_name = $row['username'];
					//$error=$user->lang['NOT_MASTER'];
				}
				else
				{
					$master_name = $user->data['username'];
					$is_master=true;
				}
				
				if ($submit != '')
				{
					switch ($submit)
					{
						case $user->lang['SWITCH_USER']:
							$forumid = request_var('switch_acct', 0);
							$redirect = request_var('redirect', $phpbb_root_path);
							
							switch_user($forumid);
						break;
						case $user->lang['LINK_USERS']:
							if ($error=='')
							{
								$data = $error = array();
								$updated = false;
								
								$master_name = $user->data['username'];
								$master_pass = request_var('master_pass', '', true);
								$linked_name = request_var('linked_name', '', true);
								$linked_pass = request_var('linked_pass', '', true);
								$result = link_account_validate ($master_name, $master_pass, $linked_name, $linked_pass);
							
								if ($result===true)
								{
									$message = $user->lang['LINK_SUCCESS'];
								}
								else
								{
									$error = $result;
								}
							}
						break;
						case $user->lang['UNLINK_USERS']:
							if ($error=='')
							{
								$usernames = request_var('usernames', array(0), true);
								if (is_array($usernames))
								{
									foreach ($usernames as $user_id)
									{
										$result = link_accounts(0, $user_id);
										$message = $user->lang['LINK_BROKEN'];
									}
								}
							}
						break;
					}
				}
				
			break;
			case 'moderate':
				$this->page_title = 'Moderate Linked Accounts';
				$this->tpl_name = 'mcp_account_link_moderate';
				if ($submit != '')
				{
					switch ($submit)
					{
						case $user->lang['LINK_USERS']:
							if ($error=='')
							{
								$data = $error = array();
								$updated = false;
								
								$master_name = request_var('master_name', '', true);
								$linked_name = request_var('linked_name', '', true);
								$result = link_account_by_name ($master_name, $linked_name);
							
								if ($result===true)
								{
									$message = $user->lang['LINK_SUCCESS'];
								} else {
									$error = $result;
								}
							}
						break;
						case $user->lang['UNLINK_USERS']:
							if ($error=='')
							{
								$usernames = request_var('usernames', array(0), true);
								if (is_array($usernames))
								{
									foreach ($usernames as $user_id)
									{
										$result = link_accounts(0, $user_id);
										$message = $user->lang['LINK_BROKEN'];
									}
								}
							}
						break;
					}
				}
			break;
		}
	
		// Template stuff
		$s_account_link_options ='';
		
		$linked_accts = get_linked_accounts();
		foreach($linked_accts as $key => $value)
		{
			if ($key != $user->data['user_id'])
			{
				$s_account_link_options .= '<option value="' . $key . '">' . $value . '</option>';
			}
		}
		
		if (!empty($error) )
		{
			$template->assign_var('ERROR', $error);
		}
		
		if (!empty($message) )
		{
			$template->assign_var('MESSAGE', $message);
		}
		
		$template->assign_vars(array( 
			'TITLE'					=> 'Linked Accounts',
			
			'IS_MASTER_ACCOUNT'		=> $is_master,
			'L_NOT_MASTER'			=> sprintf($user->lang['NOT_MASTER'],  $master_name),
			
			'U_THIS_URL'			=> $_SERVER['REQUEST_URI'],
			
			'S_ACCOUNT_LINK_OPTIONS'=> $s_account_link_options,
			'S_MASTER_NAME'			=> $master_name,
			'S_HIDDEN_FIELDS'		=> $s_hidden_fields,
			'S_UCP_ACTION'			=> $this->u_action)
		);
	}
}

?>